{CONCURRENT PASCAL-S PC Version 7.0 Source Code ................ November 1994}
{Source is compiled with Turbo Pascal 6.0 on November 1994}

{$M 65520,0,5000}

program pascals(source,config,scr,input,output);

uses  dos,
      crt,
      graph,     {library of graphics routines}
      BGIDriv;   {all BGI drivers}

label 100,200,300,400;

const nkw       = 26;                                          {NO.OF KEYWORDS}
      alng      = 20;                   {NO.OF SIGNIFICANT CHARS IN IDENTIFIER}
      llng      = 121;                                      {INPUT LINE LENGTH}
      kmax      = 10;                            {MAX NO.OF SIGNIFICANT DIGITS}
      tmax      = 150;                                          {SIZE OF TABLE}
      bmax      = 100;                                    {SIZE OF BLOCK-TABLE}
      amax      = 100;                                    {SIZE OF ARRAY-TABLE}
      cmax      = 5000;                                          {SIZE OF CODE}
      lmax      = 7;                                            {MAXIMUM LEVEL}
      smax      = 1000;                                  {SIZE OF STRING-TABLE}
      omax      = 63;                                      {HIGHEST ORDER CODE}
      xmax      = 2147483647;             {MAXIMUM LONGINT VALUE .. PATCH 1.89}
      nmax      = 2147483647;                                      {PATCH 1.88}
      lineleng  = 256;                                      {OUTPUT LINE LENGTH}
      stmax     = 15400;                        {9000+stkincr*pmax - STACKSIZE}
      stkincr   = 200;                            {STACK SIZE FOR EACH PROCESS}
      pmax      = 50;                                {MAX CONCURRENT PROCESSES}


type  symbol    = (intcon,charcon,strng,
                   notsy,plus,minus,times,idiv,imod,andsy,orsy,
                   eql,neq,gtr,geq,lss,leq,
                   lparent,rparent,lbrack,rbrack,comma,semicolon,period,
                   colon,becomes,constsy,typesy,varsy,functionsy,
                   proceduresy,arraysy,programsy,ident,
                   beginsy,ifsy,repeatsy,whilesy,forsy,
                   endsy,elsesy,untilsy,ofsy,dosy,tosy,thensy);

      index     = -xmax..+xmax;
      alfa      = packed array[1..alng] of char;
      objects   = (konstant,variable,type1,prozedure,funktion);
      types     = (notyp,ints,bools,chars,arrays,semaphore);
      er        = (erid,ertyp,erkey,erpun,erpar,ernf,erdup,erch,ersh,erln);
      symset    = set of symbol;
      typset    = set of types;
      item      = record typ:types;   ref:index; end;
      order     = packed record
                     f: -omax..+omax;
                     x: -lmax..+lmax;
                     y: -nmax..+nmax;
                     p: integer;            {PATCH 1.88 - number of parameters}
                  end;

var   source         : text;                {PATCH 1.88 .. SOURCE PROGRAM FILE}
      sourcefilename : string[14];                {PATCH 1.88 SOURCE FILE NAME}
      config         : text;                                      {config file}
      scr            : text;                                      {screen file}
      ok             : boolean;                       {PATCH 1.88 LOGICAL OKEY}
      sy             : symbol;                   {LAST SYMBOL READ BY INSYMBOL}
      id             : alfa;                         {IDENTIFIER FROM INSYMBOL}
      inum           : longint;                         {INTEGER FROM INSYMBOL}
      rnum           : real;                        {REAL NUMBER FROM INSYMBOL}
      sleng          : integer;                                 {STRING LENGTH}
      ch             : char;          {LAST CHARACTER READ FROM SOURCE PROGRAM}
      line           : array[1..llng] of char;
      cc             : integer;                             {CHARACTER COUNTER}
      ccp            : integer;          {CHARACTER COUNTER FOR ERROR MESSAGES}
      lc             : integer;                      {PROGRAM LOCATION COUNTER}
      ll             : integer;                        {LENGTH OF CURRENT LINE}
      errs           : set of er;
      errflag        : boolean;
      progname       : alfa;
      constbegsys,
      typebegsys,
      blockbegsys,
      facbegsys,
      statbegsys     : symset;
      key            : array[1..nkw] of alfa;
      ksy            : array[1..nkw] of symbol;
      sps            : array[char] of symbol;                 {SPECIAL SYMBOLS}

      beep           : string[5];
      echo           : boolean;
      cr             : string[2];
      more_count     : integer;
      key_ch         : string[10];
      more_on        : boolean;
      linelimit      : integer;
      MNE            : STRING[30];
      TRACE_FLAG     : BOOLEAN;
	PROC_FLAG      : BOOLEAN; {9/12/98}
      choice         : integer;
      stat_line      : string[80];
      compiled       : boolean;

      color_display  : boolean;                   (* color display available *)
      graphdriver    : integer;
      graphmode      : integer;
      errorcode      : integer;

      f0,b0          : byte;                            {screen default colors}
      f1,b1          : byte;      
      f2,b2          : byte;  
      f3,b3          : byte;  
      f4,b4          : byte;  
      f5,b5          : byte;


      t,a,b,sx,c1,c2 : longint;                             {INDICES TO TABLES}
      stantyps       : typset;
      disp           : array[0..lmax] of longint;

      tab            : array[0..tmax] of                     {IDENTIFIER TABLE}
                            packed record
                               name :alfa;    link   :index;
                               obj  :objects; typ    :types;
                               ref  :index;   normal :boolean;
                               lev  :0..lmax; adr    :longint;
                            end;
      atab           : array[1..amax] of                          {ARRAY TABLE}
                            packed record
                               inxtyp,eltyp :types;
                               elref,low,high,elsize,size :index;
                            end;
      btab           : array[1..bmax] of                          {BLOCK TABLE}
                            packed record
                               last,lastpar,psize,vsize :index;
                            end;
      stab           : packed array[0..smax] of char;            {STRING TABLE}

      code           : array[0..cmax] of order;                {CODE GENERATED}

      pcount         : integer;   {COUNT OF PROCESSES IN THIS PARTICULAR MODEL}

{====================================================== Patched Declarations =}
      char_val       :integer;
      res_code       :integer;

{====================================================== 5.0 SCREEN ROUTINES  =}
procedure setcolor(color1 :byte; color2 :byte);
begin
   textcolor(color1); textbackground(color2);
end;

{------------------------------------------------------------- 4.0 MNEMONIC --}
{ F. P. Genc ... December 1989 }

function MNEMONIC(var INUM :LONGINT) :string;
var m :string[25];
begin
   WITH CODE[INUM] DO
      case F of
          0:  M:= 'Load Address';
          1:  M:= 'Load Value';
          2:  M:= 'Load Indirect';
          3:  M:= 'Update Display';
          4:  M:= 'Cobegin';
          5:  M:= 'Coend';
          6:  M:= 'Wait';
          7:  M:= 'Signal';
          8:  begin case Y of 17: M:= 'Eof'; 18: M:='Eol' end; end;
         10:  M:= 'Jump to Address Y';
         11:  M:= 'Jump Y If s[t] is FALSE';
         14:  M:= 'Start of FOR Statement';
         15:  M:= 'End of FOR Statement';
         18:  M:= 'Markstack';
         19:  M:= 'Procedure call';
         21:  M:= 'Push Array Index';
         22:  M:= 'Push Block of Words';
         23:  M:= 'Move Block of Words';
         24:  M:= 'Push Literal';
         27:  M:= 'Read Value';
         28:  M:= 'Write String';
         29:  M:= 'Write Value';
         31:  M:= 'Halt';
         32:  M:= 'Return of Procedure';
         33:  M:= 'Return of Function';
         34:  M:= 's[t] := s[s[t]]';
         35:  M:= 's[t] := not s[t]';
         36:  M:= 's[t] := - s[t]';
         38:  M:= 's[s[t-1]] := s[t]';
         45:  M:= 'Test s[t-1] =  s[t]';
         46:  M:= 'Test s[t-1] <> s[t]';
         47:  M:= 'Test s[t-1] <  s[t]';
         48:  M:= 'Test s[t-1] <= s[t]';
         49:  M:= 'Test s[t-1] >  s[t]';
         50:  M:= 'Test s[t-1] >= s[t]';
         51:  M:= 's[t] := s[t-1] or  s[t]';
         52:  M:= 's[t] := s[t-1] +   s[t]';
         53:  M:= 's[t] := s[t-1] -   s[t]';
         56:  M:= 's[t] := s[t-1] and s[t]';
         57:  M:= 's[t] := s[t-1] *   s[t]';
         58:  M:= 's[t] := s[t-1] div s[t]';
         59:  M:= 's[t] := s[t-1] mod s[t]';
         62:  M:= 'Readln';
         63:  M:= 'Writeln'; 
         else M:= 'Illegal Instruction';
      end;
   MNEMONIC := M;
end; {MNEMONIC}

{--------------------------------------------------------------------- MORE --}
{ F. P. Genc ... December 1988, December 1990 }

function more :boolean;
begin
   more := false; 
   if more_on then
      begin
         more_count := more_count+1;
         if more_count > 23
            then begin
                    more_count := 1;  if echo then writeln(scr);
                    gotoxy(1,25); clreol;
                    setcolor(f1,b1);  write(' More (y/n?) ');
                    key_ch:=readkey;  writeln; setcolor(f0,b0);
                    if (key_ch = 'N') or (key_ch = 'n') then more := true
                                                        else clrscr;
                 end;
      end;
end; {more}             

{--------------------------------------------------------------- RESET_MORE --}
{ F. P. Genc ... December 1988 }

procedure reset_more (line_count : integer);
begin     
   if more_on then begin more_count := line_count; clrscr; end;
end;

{----------------------------------------------------------------- ERRORMSG --}

procedure errormsg;
var k   : er;
    msg : array[er] of alfa;
begin
   msg[erid] :='IDENTIFIER          '; msg[ertyp]:='TYPE                ';
   msg[erkey]:='KEYWORD or OPERATOR '; msg[erpun]:='PUNCTUATION         ';
   msg[erpar]:='PARAMETER           '; msg[ernf] :='NOT FOUND           ';
   msg[erdup]:='DUPLICATE           '; msg[erch] :='CHARACTER           ';
   msg[ersh] :='TOO SHORT           '; msg[erln] :='TOO LONG            ';
   writeln ('Compilation Errors');  if more then exit;
   writeln;                         if more then exit;
   for k:=erid to erln do if k in errs then 
       begin
          writeln('Error Number : ',ord(k),' -- ',msg[k]); if more then exit;
       end;
end {ERROR MSG};

{------------------------------------------------------------------- NEXTCH --}

procedure nextch;                       {READ NEXT CHARACTER; PROCESS LINE END}
begin
   if cc = ll 
      then begin 
              if eof(source)
                 then begin
                         writeln;  writeln('Program Incomplete');
                         errormsg; exit           { PATCH 1.88 } {= GOTO 99 =}
                      end;
              errflag:=true; ll:=0; cc:=0; ccp:=0;
              while not eoln(source) do
                 begin
                    ll:=ll+1; read(source,ch); if echo then write(ch); 
                    line[ll]:=ch
                 end;
              ll:=ll+1; read(source,line[ll]); write(line[ll]);
              if echo then if more then echo:=false;
           end;
   cc:=cc+1; ch:=line[cc]
end {NEXTCH};

{-------------------------------------------------------------------- ERROR --}

procedure error(n:er);
begin
   if errflag then begin errflag:=false; writeln; if more then exit; end;
   writeln(' ':ccp-2,'^ error .. ',ord(n):2);
   errs:=errs+[n]
end{ERROR};

{-------------------------------------------------------------------- FATAL --}

procedure fatal(n:integer);
var msg : array[1..6] of alfa;
begin 
   writeln; errormsg;
   msg[1]:='IDENTIFIER          '; msg[2]:='PROCEDURES          ';
   msg[3]:='STRINGS             '; msg[4]:='ARRAYS              ';
   msg[5]:='LEVELS              '; msg[6]:='CODE                ';
   writeln('Compiler table for',msg[n],' is too small');
   { PATCH 1.88 } {= GOTO 99 ==} { TERMINATE COMPILATION }
end {FATAL};

{----------------------------------------------------------------- INSYMBOL --}

procedure insymbol;{READS NEXT SYMBOL}
label 1,2,3;
var i,j,k,e : integer;
begin 
1:  while ch=' ' do nextch;

    ccp:=cc;  {save current character counter .. start of token}

    case ch of

      'A'..'Z','a'..'z':
            begin                                    {IDENTIFIER or WORDSYMBOL}
               k:=0; id:='                    ';
               repeat if k < alng then begin k:=k+1; id[k]:=upcase(ch)  end;
                  nextch
               until not( ch in ['A'..'Z','a'..'z','0'..'9','_']);

               { search keywords table .. linear search }
               j:= -1;
               for i:= 1 to nkw do if id = key[i] then j:=i;
               if j = -1 then sy:=ident else sy:=ksy[j]
            end;

      '0'..'9':
            begin                                                      {NUMBER}
               k:=0; inum:=0; sy:=intcon;
               repeat inum:=inum*10+ord(ch)-ord('0');
                  k:=k+1; nextch
               until not(ch in['0'..'9']);
               if (k > kmax) or (inum > nmax)
                  then begin error(erln); inum:=0; k:=0 end;
            end;

      ':' : begin                                            {EQUALS and COLON}
               nextch;      
               if ch = '=' then begin sy:=becomes; nextch end
                           else sy:=colon
            end;

      '<' : begin                                                   { <= or < }
               nextch;   
               if ch='=' then begin sy:=leq; nextch end else
                  if ch='>' then begin sy:=neq; nextch end else sy:=lss
            end;

      '>' : begin                                                   { >= or > }
               nextch; if ch='=' then begin sy:=geq;nextch end else sy:=gtr
            end;

      '.' : begin                                                   { .. or . }
               nextch;
               if ch='.' then begin sy:=colon; nextch end else sy:=period
            end;

      '''': begin 
               k:=0;
               2: nextch;
                  if ch=''''then begin nextch; if ch <> '''' then goto 3 end;
                  if sx+k=smax then fatal(3);
                  stab[sx+k]:=ch;k:=k+1;
                  if cc=1 then begin {END OF LINE} k:=0; end else goto 2;
               3: if k=1
                     then begin sy:=charcon;inum:=ord(stab[sx]) end
                     else if k=0 
                          then begin error(ersh);sy:=charcon;inum:=0; end
                          else begin sy:=strng;inum:=sx;sleng:=k;sx:=sx+k end
            end;

      '(' : begin 
               nextch;
               if ch <> '*' 
                  then sy:=lparent
                  else begin                                          {COMMENT}
                          nextch;
                          repeat
                             while ch <> '*' do nextch; nextch
                          until ch=')';
                          nextch; goto 1
                       end
            end;

      '{' : begin
               nextch;
               while ch <> '}' do nextch;
               nextch; goto 1;
            end;

      '+', '-', '*', '/', ')', '=', ',', '[', ']', ';':
            begin sy:=sps[ch]; nextch end;

      '$','!','@','\','}','#','_','?','"','&','|','%','~':
            begin error(erch); nextch; goto 1 end;

      else { control characters such as CR/LF  PATCH 1.88 }
            begin nextch; goto 1 end

      end

end { INSYMBOL };

{-------------------------------------------------------------------- ENTER --}

procedure enter(x0:alfa; x1:objects; x2:types; x3:longint);
begin                                               {ENTER STANDART IDENTIFIER}
   t:=t+1;
   with tab[t] do begin
                     name:=x0; link:=t-1;     obj:=x1;  typ:=x2;
                     ref:=0;   normal:=true;  lev:=0;   adr:=x3
                  end
end { ENTER };

{--------------------------------------------------------------- ENTERARRAY --}

procedure enterarray(tp:types; l,h :integer);
begin 
   if l > h then error(ertyp);
   if (abs(l) > xmax) or (abs(h) > xmax) 
      then begin error(ertyp); l:=0; h:=0; end;
   if a=amax then fatal(4) 
      else begin 
              a:=a+1;
              with atab[a] do begin inxtyp:=tp; low:=l;high:=h end
           end
end {ENTER ARRAY};

{--------------------------------------------------------------- ENTERBLOCK --}

procedure enterblock;
begin
   if b = bmax then fatal(2)
               else begin b:=b+1; btab[b].last:=0; btab[b].lastpar:=0 end
end { ENTER BLOCK };

{--------------------------------------------------------------------- EMIT --}

procedure emit(fct:integer);
begin
   if lc = cmax then fatal(6);
   code[lc].f:=fct;  code[lc].p:=0;  { PATCH 1.88 }
   lc:=lc+1
end { EMIT};

{-------------------------------------------------------------------- EMIT1 --}

procedure emit1(fct:integer;b:longint);
begin
   if lc = cmax then fatal(6);
   with code[lc] do begin f:=fct; y:=b; p:=1 { PATCH 1.88 } end;
   lc:=lc+1
end { EMIT 1};

{-------------------------------------------------------------------- EMIT2 --}

procedure emit2(fct:integer;a,b:longint);
begin
   if lc = cmax then fatal(6);
   with code[lc] do begin f:=fct; x:=a; y:=b; p:=2 end;
   lc:=lc+1;
end { EMIT 2 };

{-------------------------------------------------------------------- BLOCK --}

procedure block(fsys:symset;isfun:boolean;level:integer);

type conrec=record tp:types; i:integer end;

var dx  : longint;                                      {DATA ALLOCATION INDEX}
    prt : longint;                                  {T-INDEX OF THIS PROCEDURE}
    prb : longint;                                  {B-INDEX OF THIS PROCEDURE}
    x   : longint;

procedure skip(fsys:symset; n:er); {---------------------------------- SKIP --}
begin
   error(n); while not (sy in fsys) do insymbol;
end { SKIP };

procedure test(s1,s2:symset; n:er); {--------------------------------- TEST --}
begin
   if not (sy in s1) then skip(s1+s2,n)
end { TEST };

procedure testsemicolon; {----------------------------------- TESTSEMICOLON --}
begin
   if sy = semicolon then insymbol else error(erpun);
   test(([ident] + blockbegsys),fsys,erkey);
end { TEST SEMICOLON };

procedure enter(id:alfa; k:objects); {------------------------------- ENTER --}
var j,l : integer;
begin
   if t = tmax
      then fatal(1)
      else begin
              tab[0].name:=id; j:=btab[disp[level]].last; l:=j;
              while tab[j].name <> id do j:=tab[j].link;
              if j <> 0
                 then error(erdup)
                 else begin
                         t:=t+1;
                         with tab[t] do begin
                                           name:=id;   link:=l;   obj:=k;
                                           typ:=notyp; ref:=0;    lev:=level;
                                           adr:=0;
                                        end;
                         btab[disp[level]].last:=t
                      end
           end
end { ENTER };

function loc(id:alfa): integer; {-------------------------------------- LOC --}
var i,j: integer; { LOCATE ID IN TABLE }
begin
   i:=level; tab[0].name:=id;  { SENTINEL }
   repeat j:=btab[disp[i]].last;
      while tab[j].name <> id do j:=tab[j].link;
      i:=i-1;
   until (i < 0) or (j > 0);
   if j = 0 then error(ernf);
   loc:=j;
end { LOC };

procedure entervariable; {----------------------------------- ENTERVARIABLE --}
begin
   if sy = ident then begin enter(id,variable); insymbol end
                 else error(erid)
end { ENTER VARIABLE };

procedure constant(fsys:symset; var c:conrec); {------------------ CONSTANT --}
var x,sign: longint;
begin
   c.tp:=notyp; c.i:=0;
   test(constbegsys,fsys,erkey);
   if sy in constbegsys
      then begin
              if sy = charcon
                 then begin c.tp:=chars; c.i:=inum; insymbol end
                 else begin
                         sign:=1;
                         if sy in [plus,minus]
                            then begin
                                    if sy = minus then sign:=-1; insymbol
                                 end;
                         if sy = ident
                            then begin
                                    x:=loc(id);
                                    if x <> 0
                                       then if tab[x].obj <> konstant
                                               then error(ertyp)
                                               else begin
                                                       c.tp:=tab[x].typ;
                                                       c.i:=sign*tab[x].adr
                                                    end;
                                    insymbol
                                 end
                            else if sy = intcon
                                    then begin
                                            c.tp:=ints; c.i:=sign*inum;
                                            insymbol
                                         end
                                    else skip(fsys,erkey)
                      end;
              test(fsys,[],erkey);
           end
end { CONSTANT };

procedure typ(fsys:symset;var tp: types; var rf,sz:longint); {--------- TYP --}
var x     : longint;
    eltp  : types;
    elrf, lsz,offset,t0,t1 : longint;

procedure arraytyp(var aref,arsz:longint); {---------------------- ARRAYTYP --}
var eltp      : types;
    low,high  : conrec;
    elrf,elsz : longint;
begin
   constant( [colon,rbrack,ofsy] + fsys,low);
   if sy = colon then insymbol else error(erpun);
   constant( [rbrack,comma,ofsy] + fsys,high);
   if high.tp <> low.tp
      then begin error(ertyp); high.i:=low.i; end;
   enterarray(low.tp,low.i,high.i);
   aref:=a;
   if sy = comma
      then begin insymbol; eltp:=arrays; arraytyp(elrf,elsz) end
      else begin
              if sy = rbrack then insymbol else error(erpun);
              if sy = ofsy   then insymbol else error(erkey);
              typ(fsys,eltp,elrf,elsz)
           end;
   with atab[aref] do begin
                         arsz:=(high-low+1)*elsz;     size:=arsz;
                         eltyp:=eltp;  elref:=elrf;   elsize:=elsz
                      end;
end { ARRAY TYPE };

begin {-------------------------------------------------------- begin - TYP --}
   tp:=notyp;  rf:=0;  sz:=0;
   test(typebegsys,fsys,erid);
   if sy in typebegsys
      then begin
              if sy = ident
                 then begin
                         x:=loc(id);
                         if x <> 0
                            then with tab[x] do
                                    if obj <> type1
                                       then error(ertyp)
                                       else begin
                                               tp:=typ; rf:=ref; sz:=adr;
                                               if tp = notyp then error(ertyp)
                                            end;
                         insymbol
                      end
                 else if sy = arraysy
                         then begin
                                 insymbol;
                                 if sy = lbrack then insymbol
                                                else error(erpun);
                                 tp:=arrays;
                                 arraytyp(rf,sz)
                              end
                         else test(fsys,[ ],erkey);
           end
end { TYP };

procedure parameterlist; {----------------------------------- PARAMETERLIST --}
var tp         : types;
    rf,sz,x,t0 : longint;
    valpar     : boolean;
begin
   insymbol;   tp:=notyp;   rf:=0;   sz:=0;
   test([ident,varsy],fsys+[rparent],erpar);
   while sy in [ident,varsy]
      do begin
            if sy <> varsy then valpar:=true
                           else begin insymbol; valpar:=false end;
            t0:=t;
            entervariable;
            while sy = comma do begin insymbol; entervariable; end;
            if sy = colon
               then begin
                       insymbol;
                       if sy <> ident
                          then error(erid)
                          else begin
                                  x:=loc(id);
                                  insymbol;
                                  if x <> 0
                                     then with tab[x] do
                                             if obj <> type1
                                                then error(ertyp)
                                                else begin
                                                        tp:=typ; rf:=ref;
                                                        if valpar
                                                           then sz:=adr
                                                           else sz:=1
                                                     end;
                               end;
                       test( [semicolon,rparent],[comma,ident]+fsys,erpun)
                    end
               else error(erpun);
   while t0 < t do begin
                      t0:=t0+1;
                      with tab[t0] do begin
                                         typ:=tp;           ref:=rf;
                                         normal:=valpar;    adr:=dx;
                                         lev:=level;        dx:=dx+sz
                                      end
                   end;
   if sy <> rparent
      then begin
              if sy = semicolon then insymbol else error(erpun);
              test( [ident,varsy],[rparent]+fsys,erkey);
           end
   end { WHILE };
   
   if sy = rparent
      then begin insymbol; test([semicolon,colon],fsys,erkey) end
      else error(erpun)
end { PARAMETERLIST };

procedure constantdeclaration; {----------------------- CONSTANTDECLARATION --}
var c : conrec;
begin
   insymbol;
   test( [ident],blockbegsys,erid);
   while sy = ident do begin
                          enter(id,konstant); insymbol;
                          if sy = eql then insymbol else error(erpun);
                          constant([semicolon,comma,ident]+fsys,c);
                          tab[t].typ:=c.tp;   tab[t].ref:=0;  tab[t].adr:=c.i;
                          testsemicolon
                       end
end { CONSTANTDECLARATION };

procedure typedeclaration; {------------------------------- TYPEDECLARATION --}
var tp       : types;
    rf,sz,t1 : longint;
begin
   insymbol;
   test([ident],blockbegsys,erid);
   while sy = ident do begin
                          enter(id,type1);  t1:=t;   insymbol;
                          if sy = eql then insymbol else error(erpun);
                          typ([semicolon,comma,ident]+fsys,tp,rf,sz);
                          with tab[t1] do begin
                                             typ:=tp;  ref:=rf;  adr:=sz
                                          end;
                          testsemicolon
                       end
end { TYPE DECLARATION };

procedure variabledeclaration; {----------------------- VARIABLEDECLARATION --}
var t0,t1,rf,sz : longint;
    tp          : types;
begin
   insymbol;
   while sy = ident do begin
                          t0:=t;
                          entervariable;
                          while sy = comma do begin
                                                 insymbol; entervariable;
                                              end;
                          if sy = colon then insymbol else error(erpun);
                          t1:=t;
                          typ([semicolon,comma,ident]+fsys,tp,rf,sz);
                          while t0 < t1 do begin
                                              t0:=t0+1;
                                              with tab[t0] do begin
                                                                 typ:=tp;
                                                                 ref:=rf;
                                                                 lev:=level;
                                                                 adr:=dx;
                                                                 normal:=true;
                                                                 dx:=dx+sz
                                                              end
                                           end;
                         testsemicolon
                      end
end { VARIABLE DECLARATION };

procedure procdeclaration; {------------------------------- PROCDECLARATION --}
var isfun : boolean;
begin
   isfun:= (sy = functionsy);
   insymbol;
   if sy <> ident then begin error(erid); id:='                    '; end;
   if isfun then enter(id,funktion) else enter(id,prozedure);
   tab[t].normal:=true;   insymbol;
   block([semicolon]+fsys,isfun,level+1);
   if sy = semicolon then insymbol else error(erpun);
   emit( 32+ord(isfun) )  { EXIT }
end { PROCEDURE DECLARATION };

procedure statement(fsys:symset); {------------------------------ STATEMENT --}
var i : longint;
    x : item;
procedure expression(fsys:symset; var x:item);
forward;

procedure selector(fsys:symset; var v:item); {-------------------- SELECTOR --}
var x   : item;
    a,j : longint;
begin
   if sy <> lbrack then error(ertyp);
   repeat 
      insymbol; expression(fsys+[comma,rbrack],x);
      if v.typ <> arrays
         then error(ertyp)
         else begin
                 a:=v.ref;
                 if atab[a].inxtyp <> x.typ then error(ertyp)
                                            else emit1(21,a);
                 v.typ:=atab[a].eltyp; v.ref:=atab[a].elref
              end
   until sy <> comma;
   if sy = rbrack   then insymbol else error(erpun);
   test(fsys,[],erkey);
end { SELECTOR };

procedure call(fsys:symset; i: longint); {---------------------------- CALL --}
var x : item;
    lastp,cp,k : longint;
begin
emit1(18,i);  { MARK STACK }
lastp:=btab[ tab[i].ref ].lastpar;
cp:=i;
if sy = lparent then
   begin  { ACTUAL PARAMETER LIST }
      repeat 
        insymbol;
        if cp >= lastp then error(erpar)
           else begin
                   cp:=cp+1;
                   if tab[cp].normal
                      then begin  { VALUE PARAMETER }
                              expression(fsys+[comma,colon,rparent],x);
                              if x.typ = tab[cp].typ
                                 then begin
                                         if x.ref <> tab[cp].ref
                                            then error(ertyp)
                                            else if x.typ = arrays
                                               then emit1(22,atab[x.ref].size)
                                      end
                                 else if x.typ <> notyp then error(ertyp);
                           end
                      else begin { VARIABLE PARAMETER }
                              if sy <> ident then error(erid)
                                 else begin
                                         k:=loc(id); insymbol;
                                         if k <> 0
                                            then begin
                                                    if tab[k].obj <> variable
                                                       then error(erpar);
                                                    x.typ:=tab[k].typ;
                                                    x.ref:=tab[k].ref;
                                                    if tab[k].normal
                                                       then emit2(0,tab[k].lev,
                                                                  tab[k].adr)
                                                       else emit2(1,tab[k].lev,
                                                                  tab[k].adr);
                                                    if sy = lbrack
                                                       then selector(fsys+
                                                      [comma,colon,rparent],x);
                                                    if (x.typ<>tab[cp].typ) or
                                                       (x.ref<>tab[cp].ref)
                                                       then error(ertyp)
                                                 end
                                       end
                           end
                end;
        test([comma,rparent],fsys,erkey);
      until sy <> comma;
      if sy = rparent then insymbol else error(erpun);
   end;
if cp < lastp then error(erpar);  { TOO FEW ACTUAL PARAMETERS }
emit1(19,btab[tab[i].ref].psize-1);
if tab[i].lev < level then emit2(3,tab[i].lev,level)
end { CALL };

function resulttype(a,b:types):types; {------------------------- RESULTTYPE --}
begin
   if (a > ints) or (b > ints)
      then begin error(ertyp); resulttype:=notyp end
      else if (a = notyp) or (b = notyp)   then resulttype:=notyp
                                           else resulttype:=ints
end { RESULT TYPE };

procedure expression; {----------------------------------------- EXPRESSION --}
var y:item; op: symbol;

procedure simpleexpression(fsys:symset; var x: item);
var y: item; op:symbol;

procedure term(fsys: symset; var x:item);
var y:item; op: symbol; ts:typset;

procedure factor(fsys:symset; var x:item); {------------------------ FACTOR --}
var i,f:longint;
begin
   x.typ:=notyp;   x.ref:=0;
   test(facbegsys,fsys,erpun);
   while sy in facbegsys do
      begin
         if sy = ident
            then begin
                    i:=loc(id); insymbol;
                    with tab[i]
                        do case obj of

                           konstant: begin
                                        x.typ:=typ; x.ref:=0; emit1(24,adr)
                                     end;

                           variable: begin
                                        x.typ:=typ; x.ref:=ref;
                                        if sy = lbrack
                                           then begin
                                                   if normal then f:=0
                                                             else f:=1;
                                                   emit2(f,lev,adr);
                                                   selector(fsys,x);
                                                   if x.typ in stantyps
                                                      then emit(34)
                                                end
                                           else begin
                                                   if x.typ in stantyps
                                                      then if normal then f:=1
                                                                     else f:=2
                                                      else if normal then f:=0
                                                                     else f:=1;
                                                   emit2(f,lev,adr)
                                                end
                                     end;

                           type1,prozedure: error(ertyp);

                           funktion: begin
                                        x.typ:=typ;
                                        if lev <> 0 then call(fsys,i)
                                                    else emit1(8,adr)
                                     end;

                           end  { CASE,WITH }
                 end
            else if sy in [charcon,intcon]
                 then begin
                         if sy = charcon then x.typ:=chars
                                         else x.typ:=ints;
                         emit1(24,inum); x.ref:=0; insymbol
                      end
                 else if sy = lparent
                      then begin
                              insymbol; expression(fsys+[rparent],x);
                              if sy = rparent then insymbol else error(erpun)
                           end
                      else if sy = notsy
                              then begin
                                      insymbol; factor(fsys,x);
                                      if x.typ=bools
                                         then emit(35)
                                         else if x.typ <> notyp 
                                                 then error(ertyp)
                                   end;
      test(fsys,facbegsys,erkey);
   end { WHILE }
end { FACTOR };

begin  {------------------------------------------------------ begin - TERM --}
factor(fsys+[times,idiv,imod,andsy],x);
while sy in [times,idiv,imod,andsy]
do begin
   op:=sy;
   insymbol; factor(fsys+[times,idiv,imod,andsy],y);
   if op = times
      then begin
              x.typ:=resulttype(x.typ,y.typ);
              if x.typ = ints then emit(57)
           end
      else if op = andsy
              then begin
                      if (x.typ=bools) and (y.typ=bools)
                         then emit(56)
                         else begin
                                 if (x.typ <> notyp) and (y.typ <> notyp)
                                    then error(ertyp);
                                 x.typ:=notyp
                              end
                   end
              else begin { OP IN [ IDIV,IMOD ] }
                      if (x.typ=ints) and (y.typ=ints)
                         then if op=idiv  then emit(58) else emit(59)
                         else begin
                                 if (x.typ <> notyp) and (y.typ <> notyp)
                                    then error(ertyp);
                                 x.typ:=notyp
                              end
                   end
   end
end { TERM };

begin {-------------------------------------------- begin - SIMPLEEXPRESION --}
   if sy in [ plus,minus ]
      then begin
              op:=sy;  insymbol;
              term(fsys+[plus,minus],x);
              if x.typ > ints then error(ertyp)
                              else if op = minus then emit(36)
           end
      else term(fsys+[plus,minus,orsy],x);
   while sy in [plus,minus,orsy]
      do begin
            op:=sy;  insymbol;
            term(fsys+[plus,minus,orsy],y);
            if op = orsy
               then begin
                       if (x.typ = bools) and (y.typ = bools) 
                          then emit(51)
                          else begin
                                  if (x.typ <> notyp) and (y.typ <> notyp)
                                     then error(ertyp);
                                  x.typ:=notyp;
                               end
                    end
               else begin
                       x.typ:=resulttype(x.typ,y.typ);
                       if x.typ = ints then if op = plus then emit(52)
                                                         else emit(53)
                    end
         end
end { SIMPLE EXPRESSION };

begin {------------------------------------------------- begin - EXPRESSION --}
   simpleexpression(fsys+[eql,neq,lss,leq,gtr,geq],x);
   if sy in [eql,neq,lss,leq,gtr,geq]
      then begin
              op:=sy; insymbol; simpleexpression(fsys,y);
              if (x.typ in [notyp,ints,bools,chars]) and (x.typ = y.typ)
                 then case op of
                        eql : emit(45); neq : emit(46);
                        lss : emit(47); leq : emit(48);
                        gtr : emit(49); geq : emit(50);
                      end
                 else error(ertyp);
              x.typ:=bools
           end
end { EXPRESSION };

procedure assignment(lv,ad:longint); {-------------------------- ASSIGNMENT --}
var x,y: item; f: longint;
begin                                    { TAB[I].OBJ IN [VARIABLE,PROZEDURE] }
   x.typ:=tab[i].typ;  x.ref:=tab[i].ref;
   if tab[i].normal then f:=0 else f:=1;
   emit2(f,lv,ad);
   if sy = lbrack  then selector([becomes,eql]+fsys,x);
   if sy = becomes then insymbol else error(erpun);
   expression(fsys,y);
   if x.typ = y.typ
      then if x.typ in stantyps
              then emit(38)
              else if x.ref <> y.ref
                      then error(ertyp)
                      else if x.typ = arrays then emit1(23,atab[x.ref].size)
                                             else error(ertyp)
end { ASSIGNMENT };

procedure compoundstatement; {--------------------------- COMPOUNDSTATEMENT --}
begin
   insymbol;
   statement([semicolon,endsy]+fsys);
   while sy in [semicolon]+statbegsys
      do begin
            if sy = semicolon then insymbol else error(erpun);
            statement([semicolon,endsy]+fsys)
         end;
   if sy = endsy then insymbol else error(erkey)
end { COMPOUND STATEMENT };

procedure ifstatement; {--------------------------------------- IFSTATEMENT --}
var x        : item;
    lc1,lc2  : longint;
begin
   insymbol;
   expression(fsys+[thensy,dosy],x);
   if not(x.typ in [bools,notyp]) then error(ertyp);
   lc1:=lc; emit(11); { JMPC }
   if sy = thensy then insymbol else error(erkey);
   statement(fsys+[elsesy]);
   if sy = elsesy
      then begin
              insymbol;          lc2:=lc;           emit(10);
              code[lc1].y:=lc;   statement(fsys);   code[lc2].y:=lc
           end
      else code[lc1].y:=lc
end { IF STATEMENT };

procedure repeatstatement; {------------------------------- REPEATSTATEMENT --}
var x   : item;
    lc1 : longint;
begin
   lc1:=lc; insymbol;
   statement([semicolon,untilsy]+fsys);
   while sy in [semicolon]+statbegsys
      do begin
            if sy = semicolon then insymbol else error(erpun);
            statement([semicolon,untilsy]+fsys)
         end;
   if sy = untilsy  then begin
                            insymbol;  expression(fsys,x);
                            if not (x.typ in [bools,notyp]) then error(ertyp);
                            emit1(11,lc1)
                         end
                    else error(erkey)
end { REPEAT STATEMENT };

procedure whilestatement; {--------------------------------- WHILESTATEMENT --}
var x       : item;
    lc1,lc2 : longint;
begin
   insymbol;  lc1:=lc;  expression(fsys+[dosy],x);
   if not (x.typ in [bools,notyp]) then error(ertyp);
   lc2:=lc;   emit(11);
   if sy = dosy  then insymbol else error(erkey);
   statement(fsys);   emit1(10,lc1);   code[lc2].y:=lc
end { WHILE STATEMENT };

procedure forstatement; {------------------------------------- FORSTATEMENT --}
var cvt         : types;
    x           : item;
    i,lc1,lc2   : longint;
begin
   insymbol;
   if sy = ident
      then begin
              i:=loc(id); insymbol;
              if i = 0
                 then cvt:=ints
                 else if tab[i].obj = variable
                         then begin
                                 cvt:=tab[i].typ;
                                 if not tab[i].normal
                                    then error(ertyp)
                                    else emit2(0,tab[i].lev,tab[i].adr);
                                 if not (cvt in [notyp,ints,bools,chars]) 
                                    then error(ertyp)
                              end
                         else begin error(ertyp); cvt:=ints end
           end
      else skip([becomes,tosy,dosy]+fsys,erid);
   if sy = becomes then begin
                           insymbol; expression([tosy,dosy]+fsys,x);
                           if x.typ <> cvt then error(ertyp);
                        end
                   else skip([tosy,dosy]+fsys,erpun);
   if sy = tosy then begin
                        insymbol; expression([dosy]+fsys,x);
                        if x.typ <> cvt then error(ertyp)
                     end
                else skip([dosy]+fsys,erkey);
   lc1:=lc;  emit(14);
   if sy = dosy then insymbol else error(erkey);
   lc2:=lc;   statement(fsys);  emit1(15,lc2);  code[lc1].y:=lc
end { FOR STATEMENT };

procedure standproc(n:longint); {-------------------------------- STANDPROC --}
var i,f : longint;
    x,y : item;
begin
   case n of

   1,2: begin                                                          { READ }
        if sy = lparent
           then begin
                   repeat 
                     insymbol;
                     if sy <> ident
                        then error(erid)
                        else begin
                                i:=loc(id); insymbol;
                                if i <> 0
                                   then if tab[i].obj <> variable
                                           then error(ertyp)
                                           else begin
                                                x.typ:=tab[i].typ;
                                                x.ref:=tab[i].ref;
                                                if tab[i].normal then f:=0
                                                                 else f:=1;
                                                emit2(f,tab[i].lev,tab[i].adr);
                                                if sy = lbrack
                                                   then selector
                                                     (fsys+[comma,rparent],x);
                                                if x.typ in [ints,chars,notyp]
                                                   then emit1(27,ord(x.typ))
                                                   else error(ertyp)
                                                end
                             end;
                     test([comma,rparent],fsys,erkey)
                   until sy <> comma;
                   if sy = rparent  then insymbol else error(erpun);
                end;
       if n = 2 then emit(62)
       end;

   3,4: begin                                                         { WRITE }
        if sy = lparent
           then begin
                   repeat insymbol;
                     if sy = strng
                        then begin
                                emit1(24,sleng); emit1(28,inum); insymbol
                             end
                        else begin
                                expression(fsys+[ comma,colon,rparent],x);
                                if not (x.typ in stantyps) then error(ertyp);
                                emit1(29,ord(x.typ));
                             end
                   until sy <> comma;
                   if sy = rparent then insymbol else error(erpun)
                end;
        if n = 4 then emit(63)
        end;

   5,6: if sy <> lparent                                               { WAIT }
           then error(erpun)
           else begin
                   insymbol;
                   if sy <> ident
                      then error(erid)
                      else begin
                              i:=loc(id); insymbol;
                              if i <> 0
                                 then if tab[i].obj <> variable
                                         then error(ertyp)
                                         else begin
                                              x.typ:=tab[i].typ;
                                              x.ref:=tab[i].ref;
                                              if tab[i].normal then f:=0
                                                               else f:=1;
                                              emit2(f,tab[i].lev,tab[i].adr);
                                              if sy = lbrack
                                                 then selector(fsys+
                                                               [rparent],x);
                                              if x.typ = ints then emit(n+1)
                                                              else error(ertyp)
                                              end
                           end;
                   if sy = rparent then insymbol else error(erpun)
               end;
end { CASE }
end { STAND PROC };

begin   {------------------------------------------------ begin - STATEMENT --}
   if sy in statbegsys+[ident]
      then case sy of
           ident: begin
                  i:=loc(id); insymbol;
                  if i <> 0   then case tab[i].obj of
  
                                   konstant,
                                   type1    :error(ertyp);
                                   variable :assignment(tab[i].lev,tab[i].adr);
                                   prozedure:if tab[i].lev <> 0
                                                then call(fsys,i)
                                                else standproc(tab[i].adr);
                                   funktion :if tab[i].ref = disp[level]
                                                then assignment(tab[i].lev+1,0)
                                                else error(ertyp)
                                   end
                 end;

           beginsy  :if id = 'COBEGIN             '
                        then begin emit(4); compoundstatement; emit(5); end
                        else compoundstatement;
           ifsy     :ifstatement;
           whilesy  :whilestatement;
           repeatsy :repeatstatement;
           forsy    :forstatement;
           end {CASE};
   test(fsys,[ ],erpun)
end { STATEMENT };

begin {------------------------------------------------------ begin - BLOCK --}
   dx:=5; prt:=t;
   if level > lmax then fatal(5);
   test ([ lparent,colon,semicolon ],fsys,erpun);
   enterblock; disp[level]:=b; prb:=b;
   tab[prt].typ:=notyp; tab[prt].ref:=prb;
   if (sy = lparent) and (level > 1) then parameterlist;
   btab[prb].lastpar:=t; btab[prb].psize:=dx;
   if isfun
      then if sy = colon
              then begin
                      insymbol;  { FUNCTION TYPE }
                      if sy = ident
                         then begin
                                 x:=loc(id); insymbol;
                                 if x <> 0
                                    then if tab[x].obj <> type1
                                            then error(ertyp)
                                            else if tab[x].typ in stantyps
                                                 then tab[prt].typ:=tab[x].typ
                                                 else error(ertyp)
                              end
                         else skip([semicolon]+fsys,erid)
                   end
              else error(erpun);
   if sy = semicolon then insymbol else error(erpun);
   repeat
     if sy = constsy then constantdeclaration;
     if sy = typesy  then typedeclaration;
     if sy = varsy   then variabledeclaration;
     btab[prb].vsize:=dx;
     while sy in [proceduresy,functionsy] do procdeclaration;
     test( [beginsy],blockbegsys+statbegsys,erkey)
   until sy in statbegsys;
   tab[prt].adr:=lc;  insymbol;  statement([semicolon,endsy]+fsys);
   while sy in [semicolon]+statbegsys
      do begin
            if sy = semicolon then insymbol else error(erpun);
            statement([semicolon,endsy]+fsys)
         end;
   if sy = endsy then insymbol else error(erkey);
   test(fsys+[period],[ ],erkey);
end { BLOCK };

{---------------------------------------------------------------- INTERPRET --}

procedure interpret;

label 97,98;

const stepmax =  8;                            {MAX STEPS BEFORE PROCES SWITCH}
      tru     =  1;                                    {INTEGER  VALUE OF TRUE}
      fals    =  0;                                    {INTEGER VALUE OF FALSE}
      charl   =  0;                                 {LOWEST  CHARACTER ORDINAL}
      charh   = 63;                                 {HIGHEST CHARACTER ORDINAL}

type  ptype   = 0..pmax;                              {INDEX OF OVER PROCESSES}

var   ir           : order;                                {INSTRUCTION BUFFER}
      ps           :                                         {PROCESSOR STATUS}
                     ( run, fin, divchk, inxchk, stkchk, linchk,
                       lngchk, redchk, deadlock );
      lncnt,                                                  {NUMBER OF LINES}
      chrcnt       : integer;                    {NUMBER OF CHARACTERS IN LINE}
      h1,h2,h3,h4  : longint;                                 {LOCAL VARIABLES}

      s            : array[ 1..stmax] of longint;                   {THE STACK}

                                   {PROCESS TABLE - ONE ENTRY FOR EACH PROCESS}
      ptab         : array[ptype] of record
                           t,b,                          {TOP, BOTTOM OF STACK}
                           pc,                                {PROGRAM COUNTER}
                           stacksize: longint;                    {STACK LIMIT}
                           disp : array[1..lmax] of longint;
                           suspend : integer;         {0 OR INDEX OF SEMAPHORE}
                           active  : boolean            {PROCEDURE ACTIVE FLAG}
                     end;

      npr,                                     {NUMBER OF CONCURRENT PROCESSES}
      curpr        : ptype;                         {CURRENT PROCESS EXECUTING}
      stepcount    : integer;                {NUMBER OF STEPS BEFORE SWITCHING}
      pflag        : boolean;                            {CONCURRENT CALL FLAG}
      pcflag       : boolean;                         {CONCURRENT CALL FLAG 2 }

procedure chooseproc; {----------------------------------------- CHOOSEPROC --}
{ Modified by F. P. Genc .. 22 December 1988 }
{ FROM A RANDOM STARTING POINT SEARCH FOR A PROCESS THAT IS ACTIVE
  AND NOT SUSPENDED, D ABORTS THE INTERPRETER IF A DEADLOCK OCCURS.}
var d: integer;
begin
   d:=pcount+1;
   curpr:= (curpr + trunc(random*pcount)) mod (pcount + 1);
   while ((not ptab[curpr].active ) or (ptab[curpr].suspend <> 0 ))
         and ( d >= 0 )
      do begin d:=d-1; curpr:= (curpr+1) mod (pcount + 1) end;
   if d < 0 then begin ps:=deadlock; { GOTO 98;} end
            else stepcount:=trunc(random*stepmax) + 1;
end {CHOOSEPROC};

                   { FUNCTIONS TO CONVERT INTEGERS TO BOOLEANS AND CONVERSELY }
function itob(i:longint): boolean; {---------------------------------- ITOB --}
begin if i= tru then itob:=true else itob:=false end;

function btoi(b:boolean): longint; {---------------------------------- BTOB --}
begin if b then btoi:=tru else btoi:=fals end;

begin {-------------------------------------------------- begin - INTERPRET --}
   s[1]:=0; s[2]:=0; s[3]:=-1; s[4]:=btab[1].last;

   with ptab[0] do begin               {initialize main program process table }
                      b:=0; suspend:=0; disp[1]:=0;
                      t:=btab[2].vsize-1; pc:=tab[s[4]].adr;
                      active:=true; stacksize:=stmax-pmax*stkincr
                   end;

   for curpr:=1 to pmax do with ptab[curpr] do      {initialize process table }
       begin
          active:=false; disp[1]:=0; pc:=0; suspend:=0;
          b:=ptab[curpr-1].stacksize+1; stacksize:=b+stkincr-1; t:=b-1
       end;
 
  npr:=0;  curpr:=0; pflag:=false; stepcount:=0;
  ps:=run; lncnt:=0; chrcnt:=0; pcflag:=false;
 
 repeat {----------------------------- main interpretation loop starts HERE --}

    if ptab[0].active {if main prog. is not active, start concurrent execution}
       then curpr:=0
       else if stepcount = 0                                     { PATCH 1.88 }
               then begin 
                       chooseproc; if ps=deadlock then goto 98; 
                       {PROCESS TRACE PRINTING  ... 9/12/98.. print at process switch}
                       IF PROC_FLAG THEN
                          BEGIN
                             write('Running[',curpr:2,']');
                             write(' #steps[',stepcount:2,'] ');
				     write('Status[');
				     for h1:=0 to pcount do with ptab[h1] do
                                 begin
                                    if active then
                                       begin
                                          write(h1:2);
                                          if suspend > 0 then write('W');
                                          if h1 < pcount then write(',');
						   end;
                                 end;
                             writeln(']'); if more then exit; 
                          END;
                    end
               else stepcount:=stepcount-1;

    {TRACE printing}
    IF TRACE_FLAG THEN with ptab[curpr] do
       BEGIN
          write('pc=',pc:4,' s[t]=',s[t]:10,' s[t-1]=',s[t-1]:10,' ');
          MNE := MNEMONIC(pc);  WRITE(MNE,' ':23-LENGTH(MNE));
          with code[pc] do
             begin
                IF P >= 1 THEN WRITE(' Y=',Y:5);
                IF P = 2  THEN WRITE(' X=',X:3);
             end;
          WRITELN; IF MORE THEN EXIT;
       END;

    with ptab[curpr] do begin ir:=code[pc]; pc:=pc+1 end;

    if pflag then begin
                     if ir.f = 18 { MARKSTACK } then begin 
                                                        npr:=npr+1;
                                                        pcflag:=true;
                                                     end;
                     if pcflag then curpr:=npr else curpr:=0; 
                  end;

    with ptab[curpr] do                               { instruction execution }
      case ir.f of

      0:  begin  { LOAD ADDRESS }
             t:=t+1;
             if t > stacksize then ps:=stkchk
                              else s[t]:=disp[ir.x]+ir.y
          end;

      1:  begin  { LOAD VALUE }
             t:=t+1;
             if t > stacksize then ps:=stkchk
                              else s[t]:=s[ disp[ir.x]+ir.y ]
          end;

      2:  begin  { LOAD INDIRECT }
             t:=t+1;
             if t > stacksize then ps:=stkchk
                              else s[t]:=s[ s[ disp[ir.x]+ir.y ] ]
          end;

      3:  begin  { UPDATE DISPLAY }
             h1:=ir.y; h2:=ir.x; h3:=b;
             repeat disp[h1]:=h3; h1:=h1-1; h3:=s[h3+2]  until  h1 = h2
          end;

      4:  { COBEGIN } pflag:=true;

      5:  begin  { COEND } pflag:=false; ptab[0].active:=false end;

      6:  begin  { WAIT }
             h1:=s[t]; t:=t-1;
             if s[h1] > 0 then s[h1]:=s[h1]-1
                          else begin suspend:=h1; stepcount:=0 end
          end;

      7:  begin  { SIGNAL }
             h1:=s[t]; t:=t-1; h2:=pmax+1; h3:=trunc(random*h2);
             while ( h2 >= 0 ) and ( ptab[h3].suspend <> h1 )
               do begin h3:=(h3+1) mod (pmax+1); h2:=h2-1; end;
             if h2 < 0 then s[h1]:=s[h1]+1 else ptab[h3].suspend:=0
          end;

      8:  case ir.y of { END OF LINE and END OF FILE }
          17: begin
                 t:=t+1;
                 if t > stacksize then ps:=stkchk  else s[t]:=btoi(eof(input))
              end;
          18: begin
                 t:=t+1;
                 if t > stacksize then ps:=stkchk else s[t]:=btoi(eoln(input))
              end;
          end;

      10: pc:=ir.y; { JUMP TO ADDRESS Y }

      11: begin { CONDITIONAL JUMP TO ADDRESS Y IF S[T] IS FALSE }
             if s[t] = fals then pc:=ir.y; t:=t-1
          end;

      14: begin { START OF CODE IN FOR STATEMENT }
             h1:=s[t-1];
             if h1 <= s[t] then s[s[t-2]]:=h1 else begin t:=t-3; pc:=ir.y end
          end;

      15: begin { END OF CODE IN FOR STATEMENT - increment, test and repeat}
             h2:=s[t-2]; h1:=s[h2]+1;
             if h1 <= s[t] then begin s[h2]:=h1; pc:=ir.y end else t:=t-3;
          end;

      18: begin { MARKSTACK }
             h1:=btab[tab[ir.y].ref].vsize;
             if t+h1 > stacksize then ps:=stkchk
                else begin t:=t+5; s[t-1]:=h1-1; s[t]:=ir.y end
          end;

      19: begin {PROCEDURE CALL }
             if pflag then pcount:=pcount+1;
             active:=true; h1:=t-ir.y;
             h2:=s[h1+4];    { H2 POINTS TO TAB }
             h3:=tab[h2].lev; disp[h3+1]:=h1;
             h4:=s[h1+3]+h1;
             s[h1+1]:=pc; s[h1+2]:=disp[h3];
             if pflag then s[h1+3]:=ptab[0].b else s[h1+3]:=b;
             for h3:=t+1 to h4 do s[h3]:=0;
             b:=h1; t:=h4; pc:=tab[h2].adr;
             pcflag:=false;
          end;

     21: begin  { COMPUTE ARRAY INDEX and PUSH IT ONTO STACK }
            h1:=ir.y;      { H1 POINTS TO ATAB }
            h2:=atab[h1].low; h3:=s[t];
            if h3 < h2 then ps:=inxchk
               else if h3 > atab[h1].high then ps:=inxchk
                       else begin
                               t:=t-1;
                               s[t]:=s[t]+(h3-h2)*atab[h1].elsize
                            end
         end;

     22: begin  { LOAD A BLOCK OF WORDS ONTO STACK }
            h1:=s[t]; t:=t-1; h2:=ir.y+t;
            if h2 > stacksize then ps:=stkchk
               else while t < h2 do begin t:=t+1; s[t]:=s[h1]; h1:=h1+1 end
         end;

     23: begin  { COPY A BLOCK OF WORDS FROM ONE ADDRESS TO ANOTHER }
            h1:=s[t-1]; h2:=s[t]; h3:=h1+ir.y;
            while h1 < h3 do begin s[h1]:=s[h2]; h1:=h1+1; h2:=h2+1 end;
            t:=t-2;
         end;

     24: begin  { PUSH LITERAL ONTO STACK }
            t:=t+1;  if t > stacksize then ps:=stkchk else s[t]:=ir.y
         end;

     27: begin  { READ A VALUE }
            if eof(input) then ps:=redchk
               else case ir.y of
                         1: read(s[s[t]]);
                         3: begin read(ch); s[s[t]]:=ord(ch) end;
                    end;
            t:=t-1;
         end;

     28: begin  { WRITE STRING }
            h1:=s[t]; h2:=ir.y; t:=t-1;
            chrcnt:=chrcnt+h1; if chrcnt > lineleng then ps:=lngchk;
            repeat write(stab[h2]); h1:=h1-1; h2:=h2+1 until  h1 = 0
         end;

     29: begin  { WRITE ONE VALUE }
            if ir.y = 3 then h1:=1 else h1:=10;
            chrcnt:=chrcnt+h1;
            if chrcnt > lineleng then ps:=lngchk
               else case ir.y of
                         1: write(s[t]);
                         2: write(itob(s[t]));
                         3: if (s[t] < charl) or (s[t] > charh)
                               then ps:=inxchk else write(chr(s[t]))
                    end;
            t:=t-1;
         end;

     31: { HALT } ps:=fin;

     32: begin { RETURN FROM A PROCEDURE }
            t:=b-1; pc:=s[b+1];
            if pc <> 0 then b:=s[b+3]
                       else begin npr:=npr-1; active:=false;
                                  stepcount:=0; ptab[0].active:=(npr = 0)
                            end
         end;

     33: begin { RETURN FROM A FUNCTION } t:=b; pc:=s[b+1]; b:=s[b+3] end;

     34: s[t]:=s[s[t]]; {s[t] IS AN ADDRESS; REPLACE IT BY ITS VALUE }

     35: { NOT } s[t]:=btoi(not(itob(s[t])));

     36: { UNIRY - }   s[t]:=-s[t];

     38: begin { STORE s[t] AT ADDRESS s[t-1] } s[s[t-1]]:=s[t]; t:=t-2 end;

     45: begin { = }   t:=t-1; s[t]:=btoi(s[t] =  s[t+1]) end;

     46: begin { <> }  t:=t-1; s[t]:=btoi(s[t] <> s[t+1]) end;

     47: begin { < }   t:=t-1; s[t]:=btoi(s[t] <  s[t+1]) end;

     48: begin { <= }  t:=t-1; s[t]:=btoi(s[t] <= s[t+1]) end;

     49: begin { > }   t:=t-1; s[t]:=btoi(s[t] >  s[t+1]) end;

     50: begin { >= }  t:=t-1; s[t]:=btoi(s[t] >= s[t+1]) end;

     51: begin { OR }  t:=t-1; s[t]:=btoi(itob(s[t]) or itob(s[t+1])) end;

     52: begin { + }   t:=t-1; s[t]:=s[t] + s[t+1] end;

     53: begin { - }   t:=t-1; s[t]:=s[t] - s[t+1] end;

     56: begin { AND } t:=t-1; s[t]:=btoi(itob(s[t]) and itob(s[t+1]))  end;

     57: begin { * }   t:=t-1; s[t]:=s[t] * s[t+1] end;

     58: begin { DIV }
            t:=t-1;  if s[t+1] = 0 then ps:=divchk else s[t]:=s[t] div s[t+1]
         end;

     59: begin { MOD }
            t:=t-1;  if s[t+1] = 0 then ps:=divchk else s[t]:=s[t] mod s[t+1]
         end;

     62: { READLN } if eof(input) then ps:=redchk else readln;

     63: begin { WRITELN }
            writeln; lncnt:=lncnt+1; chrcnt:=0;
            if lncnt > linelimit then ps:=linchk;
            if more then exit;     { patch 12.12.1988 }
         end
     end   { CASE };

   until ps <> run;   { end of main interpretation loop }

   98: writeln; if more then exit;
 
       if ps <> fin then
          begin
             with ptab[curpr] do
                  write('Halt at',pc:5,' in process',curpr:4,' due to');
             case ps of
                  deadlock: writeln(' DEADLOCK');
                  divchk:   writeln(' DIVISION BY 0');
                  inxchk:   writeln(' INVALID INDEX');
                  stkchk:   writeln(' STORAGE OVERFLOW');
                  linchk:   writeln(' TOO MUCH OUTPUT');
                  lngchk:   writeln(' LINE TOO LONG');
                  redchk:   writeln(' READING PAST END OF FILE');
             end;
             if more then exit; writeln; if more then exit;
      
             writeln('Process  Active  Suspend   PC '); 
             if more then exit;
             writeln; if more then exit;
             for h1:=0 to pcount do with ptab[h1] do
                 begin
                    writeln(h1:4,' ':6,active:5,' ':4,suspend:5,'  ',pc:4);
                    if more then exit;
                 end;
             writeln; if more then exit; 

             writeln('       Global Variables       '); 
             if more then exit;
             writeln; if more then exit;
             for h1:=btab[1].last +1 to tmax  do
                 begin 
                    with tab[h1] do
                       if lev <> 1 
                          then goto 97
                          else if obj = variable then
                               if typ in stantyps then
                               case typ of
                                ints  : writeln(name,' = ',s[adr]);
                                bools : writeln(name,' = ',itob(s[adr])) ;
                                chars : writeln(name,' = ',chr(s[adr] mod 64))
                               end;
                     if more then exit;
                  end;

             97: writeln;
          end { OF BEGIN }
end { INTERPRET };

{-------------------------------------------------------------------- ABORT --}
{- Used in graphics initialization phase .. FPG .. November 1991 -}
procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

{--------------------------------------------------------------------- MAIN --}

begin {MAIN}

{------------------------------------------- init screen & set colors --------}

assign(scr,'CON'); rewrite(scr);                      {open output screen file}


{initialize graphics mode}

{ Register drivers }
if RegisterBGIdriver(@CGADriverProc)    < 0 then Abort('CGA');
if RegisterBGIdriver(@EGAVGADriverProc) < 0 then Abort('EGA/VGA');
if RegisterBGIdriver(@HercDriverProc)   < 0 then Abort('Herc');
if RegisterBGIdriver(@ATTDriverProc)    < 0 then Abort('AT&T');
if RegisterBGIdriver(@PC3270DriverProc) < 0 then Abort('PC 3270');

GraphDriver := Detect;                  { autodetect the hardware }
InitGraph(GraphDriver, GraphMode, '');  { activate graphics }
errorcode := graphresult;
color_display:= false;
if errorcode <> grOk                    { any errors? }
   then begin
           Writeln('Graphics init error: ', GraphErrorMsg(GraphDriver));
           Halt(1);
        end
   else begin if getmaxcolor > 1 then color_display:= true;   closegraph; end;

if color_display
   then begin
           f0:= lightgray;    b0:= blue;  
           f1:= white;        b1:= cyan;
        end
   else begin
           f0:= white;        b0:= black;
           f1:= black;        b1:= lightgray;
        end;                   
   
setcolor(f0,b0); clrscr; {initial screen painting}

{--------------------------------------------------------------- initialize --}

beep  := chr(7); cr := chr(13); randomize;
 
key [ 1]:='AND                 ';      key [ 2]:='ARRAY               ';
key [ 3]:='BEGIN               ';      key [ 4]:='COBEGIN             ';
key [ 5]:='COEND               ';      key [ 6]:='CONST               ';
key [ 7]:='DIV                 ';      key [ 8]:='DO                  ';
key [ 9]:='ELSE                ';      key [10]:='END                 ';
key [11]:='FOR                 ';      key [12]:='FUNCTION            ';
key [13]:='IF                  ';      key [14]:='MOD                 ';
key [15]:='NOT                 ';      key [16]:='OF                  ';
key [17]:='OR                  ';      key [18]:='PROCEDURE           ';
key [19]:='PROGRAM             ';      key [20]:='REPEAT              ';
key [21]:='THEN                ';      key [22]:='TO                  ';
key [23]:='TYPE                ';      key [24]:='UNTIL               ';
key [25]:='VAR                 ';      key [26]:='WHILE               ';

ksy [ 1]:= andsy;                      ksy [ 2]:= arraysy;
ksy [ 3]:= beginsy;                    ksy [ 4]:= beginsy;
ksy [ 5]:= endsy;                      ksy [ 6]:= constsy;
ksy [ 7]:= idiv ;                      ksy [ 8]:= dosy;
ksy [ 9]:= elsesy;                     ksy [10]:= endsy;
ksy [11]:= forsy;                      ksy [12]:= functionsy;
ksy [13]:= ifsy;                       ksy [14]:= imod;
ksy [15]:= notsy;                      ksy [16]:= ofsy;
ksy [17]:= orsy;                       ksy [18]:= proceduresy;
ksy [19]:= programsy;                  ksy [20]:= repeatsy;
ksy [21]:= thensy;                     ksy [22]:= tosy;
ksy [23]:= typesy;                     ksy [24]:= untilsy;
ksy [25]:= varsy;                      ksy [26]:= whilesy;

sps['+']:= plus;                       sps['-']:= minus;
sps['(']:= lparent;                    sps[')']:= rparent;
sps['=']:= eql;                        sps[',']:= comma;
sps['[']:= lbrack;                     sps[']']:= rbrack;
sps['"']:= neq;                        sps['&']:= andsy;
sps[';']:= semicolon;                  sps['*']:= times;

constbegsys := [ plus,minus,intcon,charcon,ident ];
typebegsys  := [ ident,arraysy ];
blockbegsys := [ constsy,typesy,varsy,proceduresy,functionsy,beginsy ];
facbegsys   := [ intcon,charcon,ident,lparent,notsy ];
statbegsys  := [ beginsy,ifsy,whilesy,repeatsy,forsy ];
stantyps    := [ notyp,ints,bools,chars,semaphore ];

{---------------------------------------------------- initialize for Menu's --}

more_on:=TRUE;
TRACE_FLAG:=FALSE;
PROC_FLAG:=FALSE;
stat_line:=' ';
ok:=FALSE;
echo:=TRUE;
sourcefilename:='';
compiled:=FALSE;
linelimit := 70;

{---------------------------------------------------------------- MAIN MENU --}
repeat
  clrscr; setcolor(f0,b0); gotoxy(1,1);
  writeln(scr,'CONCURRENT PASCAL-S  PC Version 7.1             ');
  writeln(scr,'Program modified by F. P. Genc ... 9 December 1998');
  gotoxy(1,7);
  writeln(scr,'            1. Quit');
  writeln(scr,'            2. Select Program File Name');
  writeln(scr,'            3. Compile');
  writeln(scr,'            4. Edit');
  writeln(scr,'            5. Run');
  writeln(scr,'            6. Turn on/off Listing During Compilation');
  writeln(scr,'            7. Turn on/off Run Trace');
  writeln(scr,'            8. Turn on/off Process Trace');
  writeln(scr,'            9. Turn on/off Non-stop Display');
  writeln(scr,'           10. Set  Output Line Limit');
  writeln(scr,'           11. Dump Symbol Table');
  writeln(scr,'           12. Dump Code');
  writeln(scr,'           13. Change Directory');

  setcolor(f1,b1);
  gotoxy(1,25);    clreol;  write(stat_line); stat_line:='';
  gotoxy(65,25);   write(sourcefilename);
  gotoxy(10,20);   write('Please Enter Your Choice :');
  setcolor(f0,b0); write(' ');
  readln(choice);
  case choice of
   1  : begin
          setcolor(lightgray,black); clrscr; {initialize for b/w screen}
          halt;
       end;

  2  : begin
          compiled:=FALSE;
          clrscr; exec('C:command.com','/C dir /p /w /l /oe /og');
          setcolor(f1,b1); gotoxy(1,25); clreol;
          gotoxy(10,20); write('Please enter source file name :');
          setcolor(f0,b0); write(' ');
  	  readln(sourcefilename);
          assign(source, sourcefilename);
          {$I-} reset(source); {$I+}
          ok := (ioresult  = 0);
          if not ok then
             if pos('.',sourcefilename) = 0 then
                begin
                   sourcefilename := sourcefilename+'.cp';
                   assign(source, sourcefilename);
                   {$I-} reset(source); {$I+}
                   ok := (ioresult = 0);
                   if not ok then
                      stat_line:='File : '+sourcefilename+' does not exist';
                end
             else stat_line:='File : '+sourcefilename+' does not exist';
       end;
       
  3 :  if ok then
       begin
          {--------------------------------------- initialize for compilation --}
          reset(source);
          reset_more(2);
          setcolor(f1,b1); gotoxy(1,25); clreol;
          write(scr,'COMPILATION starts now'); setcolor(f0,b0);
          gotoxy(1,1);
          lc:=0; ll:=0; cc:=0; ch:=' '; errs:=[ ];
          insymbol;                      {read first symbol from source file}
          t:=-1; a:=0; b:=1; sx:=0; c2:=0;
          disp[0]:=1;

          {check whether the first symbol is PROGRAM or not}
          if sy <> programsy then error(erkey)
   	  else begin
                  insymbol;
                  if sy <> ident then error(erid)                 {program name}
                     else begin progname:=id; insymbol; end
       	       end;

          {construct initial identifier table }
          enter('                    ', variable ,notyp, 0);             {SENTINEL}
          enter('FALSE               ', konstant ,bools, 0);
          enter('TRUE                ', konstant ,bools, 1);
          enter('CHAR                ', type1    ,chars, 1);
          enter('BOOLEAN             ', type1    ,bools, 1);
          enter('INTEGER             ', type1    ,ints , 1);
          enter('SEMAPHORE           ', type1    ,ints , 1);
          enter('EOF                 ', funktion ,bools,17);
          enter('EOLN                ', funktion ,bools,18);
          enter('READ                ', prozedure,notyp, 1);
          enter('READLN              ', prozedure,notyp, 2);
          enter('WRITE               ', prozedure,notyp, 3);
          enter('WRITELN             ', prozedure,notyp, 4);
          enter('WAIT                ', prozedure,notyp, 5);
          enter('SIGNAL              ', prozedure,notyp, 6);
          enter('                    ', prozedure,notyp, 0);

          with btab[1] do begin last:=t; lastpar:=1; psize:=0; vsize:=0 end;

          {-------------------- compile program and store code in array CODE }
          block(blockbegsys+statbegsys,false,1);
          if sy <> period then error(erpun);
          if btab[2].vsize > stmax-stkincr*pmax then error(erln);
          emit(31);                           {store a HALT statement in code}
          if not eof(source) then readln(source);
          stat_line:=beep+'COMPILATION is finished';
          compiled:=TRUE;
          if errs <> [ ] then errormsg;
          gotoxy(1,25); setcolor(f1,b1);
          write(' Press a key to return to main menu');
          key_ch:=readkey;  writeln; setcolor(f0,b0);
       end
       else stat_line:= 'Please specify a program file first';

  4:   begin
          if ok then close(source);
          swapvectors;
          if ok then exec('cedit.exe',sourcefilename)
                else exec('cedit.exe',' ');
          swapvectors;
          if ok then
             begin assign(source,sourcefilename); reset(source); end;
       end;

  5:   if compiled then
          begin
             reset_more(1); pcount:=0;
             setcolor(f1,b1); gotoxy(1,25); clreol;
             write(scr,'EXECUTION   is started');
             setcolor(f0,b0); gotoxy(1,1);
             if errs = [ ] then interpret
                else stat_line:=beep+'Execution can not start due to errors';
              gotoxy(1,25); setcolor(f1,b1);
             write(' Press a key to return to main menu');
             key_ch:=readkey;  writeln; setcolor(f0,b0);
             stat_line:=beep+'EXECUTION   is finished';
          end
       else stat_line:='Please compile your program first';

  6:   if echo then
          begin
             echo:=FALSE; stat_line:='Compiler listing is turned OFF';
          end
       else begin
               echo:=TRUE; stat_line:='Compiler listing is turned ON';
            end;

  7:   if TRACE_FLAG then
          begin
             TRACE_FLAG:=FALSE; stat_line:='Run trace is turned OFF';
          end
       else begin
               TRACE_FLAG:=TRUE; stat_line:='Run trace is turned ON';
            end;

   8:  if PROC_FLAG then
          begin
             PROC_FLAG:=FALSE; stat_line:='Process trace is turned OFF';
          end
        else begin
               PROC_FLAG:=TRUE; stat_line:='Process trace is turned ON';
             end;

  9:   if more_on then
          begin
             more_on:=FALSE; stat_line:='Display will NOT pause on every page';
          end
       else begin
               more_on:=TRUE; stat_line:='Display will pause on every page';
            end;

  10:   begin {set output line limit}
          setcolor(f1,b1); gotoxy(1,25); clreol;
          gotoxy(10,20);
          write('Please specify a total output line limit (default = 70) :');
          setcolor(f0,b0);  write(' ');
          readln(key_ch);
          if key_ch <> '' then
             begin
                val(key_ch,linelimit,ll);
                if ll <> 0 then linelimit:=70;
             end
          else key_ch:='70';
          stat_line:='Output line limit for a run is '+key_ch;
       end;
        
  11:  if compiled then
       begin
          reset_more(1);
          writeln('        NAME          OBJECT  TYPE  LINK  REF  NORMAL LEV  ADR');
          if more then goto 300;
          writeln; if more then goto 300;
          for inum:= 15 to t do with tab[inum] do
              begin
                 writeln(name,'     ',ord(obj),'      ',ord(typ),'   ',ord(link):4,
                    '  ',ord(ref):3,'   ',normal:5,' ',lev:3,adr:5);
                 if more then goto 300;
              end;
          300:
          gotoxy(1,25); setcolor(f1,b1);
          write(' Press a key to return to main menu');
          key_ch:=readkey;  writeln; setcolor(f0,b0);
       end
       else stat_line:='Please compile your program first';

  12:  If compiled then
       begin
          reset_more(1);
          writeln('ADR','   ','         CODE          ','   ','  Y  ','   ',' X '); 
          if more then exit;
          for inum := 0 to lc-1 do with code[inum] do
              begin 
                 writeln; if more then goto 400;
                 MNE := MNEMONIC(INUM);
                 write(inum:3,'   ',MNE,' ':23-LENGTH(MNE),'   ');
                 if p >= 1 then write(y:5,'   ');
                 if p  = 2 then write(x:3);
              end;
          400:
          gotoxy(1,25); setcolor(f1,b1);
          write(' Press a key to return to main menu');
          key_ch:=readkey;  writeln; setcolor(f0,b0);
       end
       else stat_line:='Please compile your program first';

  13:  begin
          clrscr; exec('command.com','/C dir /p /w /l /oe /og');
          setcolor(f1,b1); gotoxy(1,25); clreol;
          gotoxy(10,20);
          write('Please enter new directory name :');
          setcolor(f0,b0); write(' ');
          readln(key_ch);
          if key_ch <> '' then
             begin
                {$I-}
                chdir(key_ch); getdir(0,key_ch);
                if ioresult <> 0 then stat_line:='Current directory is '+key_ch;
                {$I+}
             end;
       end;

  else stat_line:='Invalid Choice';
  end; {case}
until false;
   
end.

